/*
 * URL Shortener API
 * This API is responsible of authetication and the creation, modification and deletion of uris and hooks.
 *
 * OpenAPI spec version: 0.2.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.9
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/Hook', 'model/HookRequest'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/Hook'), require('../model/HookRequest'));
  } else {
    // Browser globals (root is window)
    if (!root.UrlShortenerApi) {
      root.UrlShortenerApi = {};
    }
    root.UrlShortenerApi.HookApi = factory(root.UrlShortenerApi.ApiClient, root.UrlShortenerApi.Hook, root.UrlShortenerApi.HookRequest);
  }
}(this, function(ApiClient, Hook, HookRequest) {
  'use strict';

  /**
   * Hook service.
   * @module api/HookApi
   * @version 0.2.0
   */

  /**
   * Constructs a new HookApi. 
   * @alias module:api/HookApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the activateHook operation.
     * @callback module:api/HookApi~activateHookCallback
     * @param {String} error Error message, if any.
     * @param {module:model/Hook} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Activate a hook
     * 
     * @param {Number} hookId ID of hook to activate
     * @param {module:api/HookApi~activateHookCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/Hook}
     */
    this.activateHook = function(hookId, callback) {
      var postBody = null;

      // verify the required parameter 'hookId' is set
      if (hookId === undefined || hookId === null) {
        throw new Error("Missing the required parameter 'hookId' when calling activateHook");
      }


      var pathParams = {
        'hookId': hookId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = Hook;

      return this.apiClient.callApi(
        '/hooks/{hookId}/activate', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the createHook operation.
     * @callback module:api/HookApi~createHookCallback
     * @param {String} error Error message, if any.
     * @param {module:model/Hook} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create hook
     * @param {module:model/HookRequest} body Created hook object
     * @param {module:api/HookApi~createHookCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/Hook}
     */
    this.createHook = function(body, callback) {
      var postBody = body;

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling createHook");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = Hook;

      return this.apiClient.callApi(
        '/hooks', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the deactivateHook operation.
     * @callback module:api/HookApi~deactivateHookCallback
     * @param {String} error Error message, if any.
     * @param {module:model/Hook} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Deactivate a hook
     * 
     * @param {Number} hookId ID of hook to deactivate
     * @param {module:api/HookApi~deactivateHookCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/Hook}
     */
    this.deactivateHook = function(hookId, callback) {
      var postBody = null;

      // verify the required parameter 'hookId' is set
      if (hookId === undefined || hookId === null) {
        throw new Error("Missing the required parameter 'hookId' when calling deactivateHook");
      }


      var pathParams = {
        'hookId': hookId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = Hook;

      return this.apiClient.callApi(
        '/hooks/{hookId}/deactivate', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the deleteHook operation.
     * @callback module:api/HookApi~deleteHookCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Deletes a hook
     * 
     * @param {Number} hookId Hook id to delete
     * @param {module:api/HookApi~deleteHookCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.deleteHook = function(hookId, callback) {
      var postBody = null;

      // verify the required parameter 'hookId' is set
      if (hookId === undefined || hookId === null) {
        throw new Error("Missing the required parameter 'hookId' when calling deleteHook");
      }


      var pathParams = {
        'hookId': hookId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/hooks/{hookId}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getHook operation.
     * @callback module:api/HookApi~getHookCallback
     * @param {String} error Error message, if any.
     * @param {module:model/Hook} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Retrieve a hook
     * 
     * @param {Number} hookId ID of Hook to retrieve
     * @param {module:api/HookApi~getHookCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/Hook}
     */
    this.getHook = function(hookId, callback) {
      var postBody = null;

      // verify the required parameter 'hookId' is set
      if (hookId === undefined || hookId === null) {
        throw new Error("Missing the required parameter 'hookId' when calling getHook");
      }


      var pathParams = {
        'hookId': hookId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = Hook;

      return this.apiClient.callApi(
        '/hooks/{hookId}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getHooksByURI operation.
     * @callback module:api/HookApi~getHooksByURICallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/Hook>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Retrieves all the hooks of a URI
     * @param {String} uriId ID of URI to get hooks from
     * @param {module:api/HookApi~getHooksByURICallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/Hook>}
     */
    this.getHooksByURI = function(uriId, callback) {
      var postBody = null;

      // verify the required parameter 'uriId' is set
      if (uriId === undefined || uriId === null) {
        throw new Error("Missing the required parameter 'uriId' when calling getHooksByURI");
      }


      var pathParams = {
        'uriId': uriId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [Hook];

      return this.apiClient.callApi(
        '/uris/{uriId}/hooks', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the updateHook operation.
     * @callback module:api/HookApi~updateHookCallback
     * @param {String} error Error message, if any.
     * @param {module:model/Hook} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update hook
     * @param {Number} hookId ID of Hook to retrieve
     * @param {module:model/HookRequest} body Created hook object
     * @param {module:api/HookApi~updateHookCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/Hook}
     */
    this.updateHook = function(hookId, body, callback) {
      var postBody = body;

      // verify the required parameter 'hookId' is set
      if (hookId === undefined || hookId === null) {
        throw new Error("Missing the required parameter 'hookId' when calling updateHook");
      }

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling updateHook");
      }


      var pathParams = {
        'hookId': hookId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = Hook;

      return this.apiClient.callApi(
        '/hooks/{hookId}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
